/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.thoughtworks.xstream.XStream
 *  com.thoughtworks.xstream.io.HierarchicalStreamDriver
 *  com.thoughtworks.xstream.io.xml.DomDriver
 *  fire.pb.scene.sPos.GridPos
 *  fire.pb.scene.sPos.Position
 *  org.apache.log4j.Logger
 */
package fire.pb.scene;

import com.thoughtworks.xstream.XStream;
import com.thoughtworks.xstream.io.HierarchicalStreamDriver;
import com.thoughtworks.xstream.io.xml.DomDriver;
import fire.pb.scene.AreaInfo;
import fire.pb.scene.GotoInfo;
import fire.pb.scene.Scene;
import fire.pb.scene.sPos.GridPos;
import fire.pb.scene.sPos.Position;
import java.io.BufferedInputStream;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import org.apache.log4j.Logger;

public class BlockInfo {
    private static final Logger LOG = Logger.getLogger((String)"MAPMAIN");
    private final int MAX_WH_SIZE = 2048;
    public static final int FLOOR_0_Z = 0;
    public static final int FLOOR_1_Z = 1;
    public static final short NONE_BLOCK = 0;
    public static final short WALK_BLOCK = 1;
    public static final short FLY_BLOCK = 2;
    public static final short CHANNEL_BLOCK = 4;
    public static final short WALK_1_BLOCK = 8;
    public static final short JUMP_FIRST_BLOCK = 256;
    public static final short JUMP_SECOND_BLOCK = 512;
    public static final short JUMP_THIRD_BLOCK = 1024;
    public static final short JUMP_ALL_BLOCK = 2048;
    public static final short ALL_BLOCK = -1;
    private final int mapID;
    private int width = 0;
    private int highth = 0;
    private short[] info = null;
    final List<GridPos> list = new ArrayList<GridPos>();
    final List<GridPos> toufangList = new ArrayList<GridPos>();
    boolean hasToufangArea = false;
    final List<GridPos> toufang2List = new ArrayList<GridPos>();
    boolean hasToufang2Area = false;
    final List<GridPos> pickupList = new ArrayList<GridPos>();
    final Map<Integer, AreaInfo> areaInfos = new HashMap<Integer, AreaInfo>();
    private Map<Integer, GotoInfo> channels = new HashMap<Integer, GotoInfo>();

    public final int getWidth() {
        return this.width;
    }

    public final int getHighth() {
        return this.highth;
    }

    public BlockInfo(int mapID) {
        this.mapID = mapID;
    }

    void genNoneBlockList() {
        for (int x = 0; x < this.getWidth(); ++x) {
            for (int y = 0; y < this.getHighth(); ++y) {
                if (this.checkBlock(x, y, (short)1) || this.checkBlock(x, y, (short)4)) continue;
                this.list.add(new GridPos(x, y));
            }
        }
        Collections.shuffle(this.list);
        Collections.shuffle(this.list);
        Collections.shuffle(this.list);
    }

    void genToufangPosList() {
        for (int x = 0; x < this.getWidth(); ++x) {
            for (int y = 0; y < this.getHighth(); ++y) {
                if (this.checkCanToufang(x, y)) {
                    this.toufangList.add(new GridPos(x, y));
                    this.toufang2List.add(new GridPos(x, y));
                }
                if (this.checkTnsh(x, y)) {
                    this.pickupList.add(new GridPos(x, y));
                }
                if (!this.checkToufang2(x, y)) continue;
                this.toufang2List.add(new GridPos(x, y));
            }
        }
        if (!this.toufangList.isEmpty()) {
            this.hasToufangArea = true;
        }
        Collections.shuffle(this.toufangList);
        Collections.shuffle(this.toufangList);
        Collections.shuffle(this.pickupList);
        Collections.shuffle(this.pickupList);
    }

    public boolean checkCanToufang(int x, int y) {
        AreaInfo areaInfo = this.areaInfos.get((x << 16) + y);
        if (areaInfo != null) {
            return areaInfo.isToufangArea() && !this.checkBlock(x, y, (short)1);
        }
        return false;
    }

    public boolean checkToufang2(int x, int y) {
        AreaInfo areaInfo = this.areaInfos.get((x << 16) + y);
        if (areaInfo != null) {
            return areaInfo.isToufang2Area() && !this.checkBlock(x, y, (short)1);
        }
        return false;
    }

    public boolean checkCanBaitan(int x, int y) {
        AreaInfo areaInfo = this.areaInfos.get((x << 16) + y);
        if (areaInfo != null) {
            return areaInfo.isBaitanArea();
        }
        return false;
    }

    public boolean checkCanQiecuo(int x, int y) {
        AreaInfo areaInfo = this.areaInfos.get((x << 16) + y);
        if (areaInfo != null) {
            return areaInfo.isQiecuoArea();
        }
        return false;
    }

    public boolean checkCanKite(int x, int y) {
        AreaInfo areaInfo = this.areaInfos.get((x << 16) + y);
        if (areaInfo != null) {
            return areaInfo.isKite();
        }
        return false;
    }

    public boolean checkTnsh(int x, int y) {
        if (this.checkBlock(x, y, (short)1)) {
            return false;
        }
        AreaInfo areaInfo = this.areaInfos.get((x << 16) + y);
        if (areaInfo != null) {
            return areaInfo.isTnsh();
        }
        return false;
    }

    public List<GridPos> getNoneBlockListBetweenXAndY(GridPos leftTop, GridPos rightLow) {
        ArrayList<GridPos> noneBlockList = new ArrayList<GridPos>();
        for (int x = leftTop.getX(); x < rightLow.getX(); ++x) {
            for (int y = leftTop.getY(); y < rightLow.getY(); ++y) {
                if (this.checkBlock(x, y, (short)1)) continue;
                noneBlockList.add(new GridPos(x, y));
            }
        }
        return noneBlockList;
    }

    public List<GridPos> getNoneBlockAndTouFangListBetweenXAndY(GridPos leftTop, GridPos rightLow) {
        ArrayList<GridPos> noneBlockList = new ArrayList<GridPos>();
        for (int x = leftTop.getX(); x < rightLow.getX(); ++x) {
            for (int y = leftTop.getY(); y < rightLow.getY(); ++y) {
                if (this.checkBlock(x, y, (short)1)) continue;
                if (this.hasToufangArea) {
                    if (!this.checkCanToufang(x, y)) continue;
                    noneBlockList.add(new GridPos(x, y));
                    continue;
                }
                noneBlockList.add(new GridPos(x, y));
            }
        }
        return noneBlockList;
    }

    public List<GridPos> getNoneBlockList() {
        return this.list;
    }

    public List<GridPos> getToufangList() {
        return this.toufangList;
    }

    public List<GridPos> getToufang2List() {
        return this.toufang2List;
    }

    public List<GridPos> getPickupList() {
        return this.pickupList;
    }

    public String getMapFileName() {
        return "gamedata/map/" + this.mapID + "/maze.dat";
    }

    public String getJumpBlockFileName() {
        return "gamedata/map/" + this.mapID + "/JumpBlock.dat";
    }

    public String getAreaFileName() {
        return "gamedata/map/" + this.mapID + "/regiontypeinfo.dat";
    }

    private final short getPosBlock(int x, int y) {
        int pos;
        if (x >= 0 && y >= 0 && x < this.width && y < this.highth && (pos = y * this.width + x) < this.info.length) {
            return this.info[pos];
        }
        return -1;
    }

    private void setPosChannelBlock(int x, int y) {
        int pos;
        if (x < this.width && y < this.highth && (pos = y * this.width + x) < this.info.length) {
            this.info[pos] = 4;
        }
    }

    public boolean checkBlock(int x, int y, short blockType) {
        short bt = this.getPosBlock(x, y);
        return 0 != (blockType & bt);
    }

    public final boolean checkBlock(GridPos grid, short blockType) {
        return this.checkBlock(grid.getX(), grid.getY(), blockType);
    }

    public final boolean checkBlock(Position pos, short blockType) {
        return this.checkBlock(pos.getX() / 16, pos.getY() / 16, blockType);
    }

    public final boolean checkBaitan(GridPos grid) {
        return this.checkCanBaitan(grid.getX(), grid.getY());
    }

    final boolean checkTolerableBlock(Position pos, short blockType) {
        GridPos grid = pos.toGridPos();
        if (grid.getX() < 0 || grid.getY() < 0 || grid.getX() >= this.width || grid.getY() >= this.highth) {
            return false;
        }
        if (!this.checkBlock(grid, blockType)) {
            return false;
        }
        return !this.checkAdjacentPosThrough(pos, blockType);
    }

    private boolean checkAdjacentPosThrough(Position blockPos, short blockType) {
        int x = 0;
        int y = 0;
        x = (blockPos.getX() - 2) / 16;
        y = blockPos.getY() / 16;
        if (x > 0 && !this.checkBlock(x, y, blockType)) {
            return true;
        }
        x = (blockPos.getX() + 2) / 16;
        if (!this.checkBlock(x, y = blockPos.getY() / 16, blockType)) {
            return true;
        }
        x = blockPos.getX() / 16;
        y = (blockPos.getY() - 2) / 16;
        if (y > 0 && !this.checkBlock(x, y, blockType)) {
            return true;
        }
        x = blockPos.getX() / 16;
        return !this.checkBlock(x, y = (blockPos.getY() + 2) / 16, blockType);
    }

    private boolean checkThrough(Position src, Position dest, short blockType) {
        if (this.checkTolerableBlock(src, blockType)) {
            return false;
        }
        if (this.checkTolerableBlock(dest, blockType)) {
            return false;
        }
        Position mid = src.getMidPos(dest);
        if (this.checkTolerableBlock(mid, blockType)) {
            return false;
        }
        if (mid.checkInSameGrid(src) || mid.checkInSameGrid(dest)) {
            return true;
        }
        return this.checkThrough(src, mid, blockType) && this.checkThrough(mid, dest, blockType);
    }

    public boolean checkWay(List<Position> pos, short blockType) {
        int sz = pos.size();
        if (sz <= 1) {
            return true;
        }
        for (int i = 0; i < sz - 1; ++i) {
            if (this.checkThrough(pos.get(i), pos.get(i + 1), blockType)) continue;
            return false;
        }
        return true;
    }

    public boolean existMazeFile() {
        File mazefile = new File(this.getMapFileName());
        return mazefile.exists();
    }

    public void loadMap() {
        try {
            byte[] mazes = this.loadMaze();
            if (mazes == null) {
                Scene.LOG.error((Object)("地图 ： " + this.mapID + " 的maze.dat不存在"));
                return;
            }
            Map<Integer, Byte> jumpblocks = this.loadJumpBlock();
            this.info = new short[mazes.length];
            for (int i = 0; i < mazes.length; ++i) {
                int x = i % this.width;
                int y = i / this.width;
                int xy = (x << 16) + y;
                Byte jumpblock = jumpblocks.get(xy);
                if (jumpblock == null) {
                    jumpblock = 0;
                }
                this.info[i] = (short)(BlockInfo.ByteToShort(jumpblock) << 8 | BlockInfo.ByteToShort(mazes[i]));
            }
        }
        catch (Exception e) {
            LOG.error((Object)e);
        }
    }

    public byte[] loadMaze() {
        String filename = this.getMapFileName();
        byte[] blocks = null;
        try {
            File file = new File(filename);
            if (!file.exists()) {
                return blocks;
            }
            DataInputStream in = new DataInputStream(new BufferedInputStream(new FileInputStream(file)));
            int headLen = Integer.reverseBytes(in.readInt());
            this.width = Integer.reverseBytes(in.readInt());
            this.highth = Integer.reverseBytes(in.readInt());
            blocks = new byte[this.width * this.highth];
            if (-1 == this.width || -1 == this.highth || this.width > 2048 || this.highth > 2048) {
                in.close();
                throw new Exception("初始化地图文件数值错误" + filename);
            }
            int ret = in.read(blocks);
            if (-1 == ret) {
                in.close();
                throw new Exception("初始化地图文件阻挡信息有误" + filename);
            }
            in.close();
            LOG.debug((Object)("minLen\t" + headLen + "\twidth\t" + this.width + "\thighth\t" + this.highth + "\t"));
        }
        catch (Exception e) {
            LOG.error((Object)("加载地图" + this.mapID + "的maze.dat时出错"), (Throwable)e);
        }
        return blocks;
    }

    public Map<Integer, Byte> loadJumpBlock() {
        HashMap<Integer, Byte> infos = new HashMap<Integer, Byte>();
        String filePath = this.getJumpBlockFileName();
        File f = new File(filePath);
        if (!f.exists()) {
            return infos;
        }
        try {
            DataInputStream in = new DataInputStream(new BufferedInputStream(new FileInputStream(filePath)));
            Integer.reverseBytes(in.readInt());
            Integer.reverseBytes(in.readInt());
            Integer.reverseBytes(in.readInt());
            int count = Integer.reverseBytes(in.readInt());
            for (int i = 0; i < count; ++i) {
                int pos = Integer.reverseBytes(in.readInt());
                byte val = in.readByte();
                infos.put(pos, val);
            }
            in.close();
            return infos;
        }
        catch (Exception e) {
            LOG.error((Object)("加载地图" + this.mapID + "的JumpBlock.dat时出错"), (Throwable)e);
            return new HashMap<Integer, Byte>();
        }
    }

    public void loadArea() {
        HashMap<Integer, Short> infos = new HashMap<Integer, Short>();
        String filePath = this.getAreaFileName();
        File f = new File(filePath);
        if (!f.exists()) {
            return;
        }
        if (f.length() <= 0L) {
            return;
        }
        try {
            DataInputStream in = new DataInputStream(new BufferedInputStream(new FileInputStream(filePath)));
            Integer.reverseBytes(in.readInt());
            Integer.reverseBytes(in.readInt());
            Integer.reverseBytes(in.readInt());
            int count = Integer.reverseBytes(in.readInt());
            for (int i = 0; i < count; ++i) {
                int pos = Integer.reverseBytes(in.readInt());
                short val = Short.reverseBytes(in.readShort());
                infos.put(pos, val);
            }
            in.close();
        }
        catch (Exception e) {
            e.printStackTrace();
            LOG.info((Object)new StringBuffer().append(e).append(" ").append(filePath));
        }
        for (Map.Entry entry : infos.entrySet()) {
            short value = (Short)entry.getValue();
            boolean isQiecuo = (value & 1) == 1;
            boolean isTnsh = (value & 2) == 2;
            boolean isToufang = (value & 0x10) == 16;
            boolean isToufang2 = (value & 0x40) == 64;
            boolean isBaitan = (value & 4) == 4;
            boolean isKite = (value & 8) == 8;
            HashSet<Short> areaTypes = new HashSet<Short>(8);
            for (int i = 10; i <= 16; i = (int)((short)(i + 1))) {
                if ((value & (short)(1 << i)) == 0) continue;
                areaTypes.add((short)(i + 1));
            }
            AreaInfo areaInfo = new AreaInfo(isBaitan, isQiecuo, isToufang, isToufang2, isKite, isTnsh, areaTypes);
            this.areaInfos.put((Integer)entry.getKey(), areaInfo);
        }
    }

    private String getGotoFileName() {
        return "gamedata/map/" + this.mapID + "/goto.xml";
    }

    public void loadChannels() {
        XStream s = new XStream((HierarchicalStreamDriver)new DomDriver());
        s.alias("data", List.class);
        s.alias("item", GotoInfo.class);
        s.useAttributeFor(GotoInfo.class, "posx");
        s.useAttributeFor(GotoInfo.class, "posy");
        s.useAttributeFor(GotoInfo.class, "destmap");
        s.useAttributeFor(GotoInfo.class, "destx");
        s.useAttributeFor(GotoInfo.class, "desty");
        try {
            List gotoItems = (List)s.fromXML((InputStream)new FileInputStream(this.getGotoFileName()));
            for (GotoInfo item : gotoItems) {
                this.setPosChannelBlock(item.getX(), item.getY());
                this.channels.put((item.getX() << 16) + item.getY(), item);
            }
        }
        catch (FileNotFoundException fileNotFoundException) {
            // empty catch block
        }
    }

    GotoInfo getGotoInfo(int x, int y) {
        return this.channels.get((x << 16) + y);
    }

    public Map<Integer, AreaInfo> getAreaInfos() {
        return this.areaInfos;
    }

    public boolean isInMapScale(Position pos) {
        if (pos.getX() < 0 || pos.getX() >= this.getWidth() * 16) {
            return false;
        }
        return pos.getY() >= 0 && pos.getY() < this.getHighth() * 16;
    }

    public boolean isInMapScale(GridPos gpos) {
        if (gpos.getX() < 0 || gpos.getX() >= this.getWidth()) {
            return false;
        }
        return gpos.getY() >= 0 && gpos.getY() < this.getHighth();
    }

    public List<GridPos> getAroundGridPoses(GridPos cgpos, int r) {
        int y;
        GridPos gpos;
        int x;
        ArrayList<GridPos> ret = new ArrayList<GridPos>();
        if (r > 500) {
            return ret;
        }
        int leftx = cgpos.getX() - r;
        int rightx = cgpos.getX() + r;
        int upy = cgpos.getY() - r;
        int downy = cgpos.getY() + r;
        for (x = leftx; x < rightx; ++x) {
            gpos = new GridPos(x, upy);
            if (!this.isInMapScale(gpos)) continue;
            ret.add(gpos);
        }
        for (y = upy; y < downy; ++y) {
            gpos = new GridPos(rightx, y);
            if (!this.isInMapScale(gpos)) continue;
            ret.add(gpos);
        }
        for (x = rightx; x > leftx; --x) {
            gpos = new GridPos(x, downy);
            if (!this.isInMapScale(gpos)) continue;
            ret.add(gpos);
        }
        for (y = downy; y > upy; --y) {
            gpos = new GridPos(leftx, y);
            if (!this.isInMapScale(gpos)) continue;
            ret.add(gpos);
        }
        return ret;
    }

    private void getMids(Position src, Position dest, List<Position> ret) {
        if (src.checkInSameGrid(dest)) {
            return;
        }
        Position mid = src.getMidPos(dest);
        if (mid.checkInSameGrid(src) || mid.checkInSameGrid(dest)) {
            return;
        }
        if (!mid.checkInSameGrid(src)) {
            this.getMids(src, mid, ret);
        }
        ret.add(mid);
        if (!mid.checkInSameGrid(dest)) {
            this.getMids(mid, dest, ret);
        }
    }

    public void getLinePositions(Position src, Position dest, List<Position> ret) {
        ret.add(src);
        if (src.checkInSameGrid(dest)) {
            return;
        }
        this.getMids(src, dest, ret);
        ret.add(dest);
    }

    public static short ByteToShort(byte b) {
        int tmp = 1;
        short s = 0;
        for (int i = 0; i < 8; ++i) {
            if ((tmp & b) != 0) {
                s = (short)(s | tmp);
            }
            tmp <<= 1;
        }
        return s;
    }
}

